# psb_qaqc
QAQC実施直後にmasterでログをまとめるときに使うコマンドのマニュアル。

## シフトでの使い方

### 1. masterのログをCSVに変換する

```
# psb-qaqc add-master-log <LOG FILE> <DATABASE CSV>
```

```sh
psb-qaqc add-master-log ./logs/20.log out_20.csv
```

### 2. 再試験にまわすボードを決める
TODO: 判断基準

masterのログまたはcsvを参照しながら再試験するかを判断し、
再試験するものはさっき作ったcsvファイルの右側の`false`を`true`に書き換える。
また、その右側にコメントを書き加える。

[CSVへの書き込みについて](#CSVへの書き込みについて)

### 3. Google sheetsにアップロードする
CSVをコピーして、[Google sheets](https://docs.google.com/spreadsheets/d/128qOseOy4QDotehYe4Wf2jj88tnwiXGVdR3NHrjcDYU/edit?pli=1&gid=408695746#gid=408695746)の一番下に加える。
*列をわける*のようなものを選択するとうまく貼れる。

### 4. CSVの後処理
アップロード済みである(編集しない)ことを明らかにするために、`log`ディレクトリに`_uploaded.csv`の名前にして移動させる。

## 機能
サブコマンドごとに機能がわかれている。
各コマンドで`--help`を渡せばヘルプがみれる。

### `add-master-log`
QAQC実施直後にMaster JATHub上で実行することでMasterでのログをCSVに書き加える。

```
# psb-qaqc add-master-log <LOG FILE> <DATABASE CSV>
```

```sh
psb-qaqc add-master-log ./logs/20.log out.csv
```

### `check-db`
CSVファイルのフォーマットが正常か確認する。
正常でない場合、0以外を返す。

```sh
psb-qaqc check-db out.csv
```

## CSVへの書き込みについて
CSVの一番最後の列にコメントを書き込めるようにしている。
以下コメントを書き込む際の注意点・推奨事項:

- `" "` で囲む
- `,`は書き込める
- `"`を使うときは`""`のように重ねてかく
- 一番うしろには`,`を書かない

*例*
```csv
,,"日本語も,かけます ""field"""
```

編集前にバックアップを作成することを推奨します。

